<template>
  <div class="app-container">

    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="85px">
      <el-form-item label="康复批次号" prop="batchno">
        <el-input v-model="queryParams.batchno" placeholder="请输入康复批次号" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="地址" prop="schoolName">
        <el-input v-model="queryParams.schoolName" placeholder="请输入地址" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <!-- <el-form-item label="班级名称" prop="className">
        <el-input v-model="queryParams.className" placeholder="请输入班级名称" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item> -->
      <el-form-item label="性别" prop="sex">
        <!-- <el-input v-model="queryParams.sex" placeholder="请输入性别" clearable @keyup.enter.native="handleQuery"/> -->
        <el-select v-model="queryParams.sex" placeholder="请输入性别" clearable >
              <el-option v-for="dict in sexDictDatas" :key="parseInt(dict.value)" :label="dict.label" :value="parseInt(dict.value)"/>
        </el-select>
      </el-form-item>
      <el-form-item label="康复项目" prop="itemname">
        <el-input v-model="queryParams.itemname" placeholder="请输入康复项目" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="时间" prop="createTime">
        <el-date-picker v-model="queryParams.createTime" style="width: 240px" value-format="yyyy-MM-dd HH:mm:ss" type="daterange"
                        range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期" :default-time="['00:00:00', '23:59:59']" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <!-- <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                   v-hasPermi="['system:order:create']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport" :loading="exportLoading"
                   v-hasPermi="['system:order:export']">导出</el-button>
      </el-col> -->
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport" :loading="exportLoading"
                   v-hasPermi="['system:order:export']">导出</el-button>
      </el-col>

      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 列表 -->
    <el-table v-loading="loading" :data="list">
      <el-table-column label="康复项目" align="center" prop="itemname" width="180"/>
      <el-table-column label="康复批次号" align="center" prop="batchno" width="180"/>
      <el-table-column label="地址" align="center" prop="schoolName" />
      <!-- <el-table-column label="班级名称" align="center" prop="className" /> -->
      <el-table-column label="性别" align="center" prop="sex" >
        <template slot-scope="scope">
          <dict-tag :type="DICT_TYPE.SYSTEM_USER_SEX" :value="scope.row.sex"/>
        </template>
      </el-table-column >
      <el-table-column label="人数" align="center" prop="patCount" />
      <el-table-column label="金额" align="center" prop="priceSum" />
    </el-table>
    <!-- 分页组件 -->
    <!-- <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/> -->

  </div>
</template>

<script>
import { getOrderSumList, exportOrderSumExcel } from "@/api/system/order";
import {DICT_TYPE, getDictDatas} from "@/utils/dict";

export default {
  name: "OrderSum",
  components: {
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 检查项目订单列表
      list: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        batchno: null,
        schoolName: null,
        className: null,
        sex: null,
        itemname: null,
        createTime: [],
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        batchno: [{ required: true, message: "康复批次号不能为空", trigger: "blur" }],
        patid: [{ required: true, message: "病人唯一标识不能为空", trigger: "blur" }],
        packageflag: [{ required: true, message: "套餐标识（0非套餐 1套餐 ）不能为空", trigger: "blur" }],
        packageno: [{ required: true, message: "套餐代码 目前只有一个基础包不能为空", trigger: "blur" }],
        itemflag: [{ required: true, message: "标识（1小项目 2临床 ）不能为空", trigger: "blur" }],
        itemno: [{ required: true, message: "项目代码不能为空", trigger: "blur" }],
      },
      sexDictDatas: getDictDatas(DICT_TYPE.SYSTEM_USER_SEX),
      feeDictDatas: getDictDatas(DICT_TYPE.FEE_FLAG)
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询列表 */
    getList() {
      this.loading = true;
      // 执行查询
      getOrderSumList(this.queryParams).then(response => {
        this.list = response.data;
        // this.total = response.data.total;
        this.loading = false;
      });
    },
    /** 取消按钮 */
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        batchno: undefined,
        patid: undefined,
        orderno: undefined,
        packageflag: undefined,
        packageno: undefined,
        itemflag: undefined,
        itemno: undefined,
        itemname: undefined,
        itemprice: undefined,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加检查项目订单";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id;
      getOrder(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改检查项目订单";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (!valid) {
          return;
        }
        // 修改的提交
        if (this.form.id != null) {
          updateOrder(this.form).then(response => {
            this.$modal.msgSuccess("修改成功");
            this.open = false;
            this.getList();
          });
          return;
        }
        // 添加的提交
        createOrder(this.form).then(response => {
          this.$modal.msgSuccess("新增成功");
          this.open = false;
          this.getList();
        });
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const id = row.id;
      this.$modal.confirm('是否确认删除康复项目订单编号为"' + id + '"的数据项?').then(function() {
          return deleteOrder(id);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = {...this.queryParams};
      params.pageNo = undefined;
      params.pageSize = undefined;
      this.$modal.confirm('是否确认导出所有康复项目订单数据项?').then(() => {
          this.exportLoading = true;
          return exportOrderSumExcel(params);
        }).then(response => {
          this.$download.excel(response, '康复项目统计.xls');
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
